<?php

if (!defined('_PS_VERSION_')) {
    exit;
}
class SwipeCallbackModuleFrontController extends ModuleFrontController {

    public function postProcess() {
        $td_user_data = explode(" ", $_REQUEST["td_user_data"]);
        $cart = new Cart($td_user_data[0]);
        if ($cart->id_customer != 0 || $cart->id_address_delivery != 0 || $cart->id_address_invoice != 0 || $this->module->active || $cart->id == $td_user_data[0]) {//Ensure cart loaded properly
            if ($_REQUEST["status"] == "accepted" || ($_REQUEST['status'] == 'test-accepted' && Configuration::get("SWIPE_TEST_MODE")=='yes') ) {
                $total = (float) $cart->getOrderTotal(true, Cart::BOTH);
                $transaction_vars = array("transaction_id" => $_REQUEST["transaction_id"]);
                if($_REQUEST['status'] == 'test-accepted'){
                    $message = "Transaction result is test-accepted / Transaction ID '".$_REQUEST["transaction_id"]."'";
                }
                else{
                    $message = "Card Holder Name - '" . $_REQUEST["name_on_card"] . "' /  Transaction ID '" . $_REQUEST["transaction_id"] . "'";
                }
                $this->module->validateOrder((int) $cart->id, Configuration::get("SWIPE_OS"), $total, $this->module->displayName, $message, $transaction_vars, NULL, false, $td_user_data[1]);
            }
            //added in plugin v1.7
            else if($_REQUEST["status"] == "test-declined" || $_REQUEST["status"] == "declined"){
                $total = (float) $cart->getOrderTotal(true, Cart::BOTH);
                $transaction_vars = array("transaction_id" => $_REQUEST["transaction_id"]);
                if($_REQUEST["status"] == "test-declined" && Configuration::get("SWIPE_TEST_MODE")=='yes'){
                    $message = "Transaction result is test-declined";
                }
                else{
                    $message = "Transaction declined";
                }
                $this->module->validateOrder((int) $cart->id, Configuration::get("PS_OS_ERROR"), $total, $this->module->displayName, $message, $transaction_vars, NULL, false, $td_user_data[1]);
            }
        }
    }
}